use crate::{Entity, model::Modelable};

use std::marker::PhantomData;

pub struct Builder { }

impl Builder {
    pub fn get<T: Entity>() -> Select<T> { Select { _ghost: PhantomData } }
}

pub struct Select<T: Entity> {
    _ghost: PhantomData<T>,
}

/*impl<T: Entity> Select<T> {
}*/

pub trait Selectable {
    type Table: Entity;

    fn given<G: Modelable>(self, column: <Self::Table as Entity>::Column, given: G) -> SelectGiven<Self, Self::Table, G> where Self: Sized;
    // fn given_id(self, id: <Self::Table as Entity>::ID) -> SelectGiven<Table = Self::Table> where Self: Sized;
}

pub struct SelectGiven<S: Selectable<Table = T>, T: Entity, Given: Modelable> {
    column: <T as Entity>::Column,
    _ghost: (PhantomData<S>, PhantomData<Given>)
}

impl<S: Selectable<Table = T>, T: Entity, Given: Modelable> Selectable for SelectGiven<S, T, Given> {
    type Table = T;

    fn given<G: Modelable>(self, column: <Self::Table as Entity>::Column, given: G) -> SelectGiven<Self, Self::Table, G> where Self: Sized {
        todo!()
    }
}
